# Something Worth Implementation

## Coroutine
* [bigger-coroutine](https://codereview.stackexchange.com/questions/151211/bigger-coroutine-class)

## Checked (Strong Type)
* [checked](https://github.com/MichaelSuen-thePointer/checked/blob/master/checked/checked.h)

## Malloc
* [dlmalloc](https://github.com/greg7mdp/dlmalloc/)

## Compile-time x86 Assembly
* [ctai](https://github.com/stryku/ctai)

## Break-for-each
* [Kotlin-way](https://zhuanlan.zhihu.com/p/26683156)
* or filter + foreach

## qsort
* [glibc-qsort](https://www.zhihu.com/question/39214230/answer/80244880)

## Meta Algorithms
* [metal](https://github.com/odinthenerd/metal)
* [mpl11](https://github.com/ldionne/mpl11)

## Concept-based Polymorphism
* [dyno](https://github.com/ldionne/dyno)

## Recursively visit
* [video](https://www.youtube.com/watch?v=mqei4JJRQ7s&index=1&list=PL9hrFapz4dsMQuBQTnHXogJpMj6L_EQ10)
* Y-combinator + Lambda
* [talk](https://github.com/SuperV1234/accu2017/blob/master/implementing_variant_visitation_using_lambdas/talk.pdf)
* [repo](https://github.com/SuperV1234/scelta)

## Generic Hasher
* boost.hash

## Cmdline
* [github](https://github.com/tanakh/cmdline)

## Meta
* [ctti](https://github.com/Manu343726/ctti)
* compile-time math function
* compile-time matrix
* [cx](https://github.com/elbeno/constexpr)
* [parser](https://github.com/lefticus/constexpr_all_the_things/blob/master/src/include/cx_parser.h)
* [petra](https://github.com/jacquelinekay/petra)
* + compile-time-result -> runtime-access (set jump table)
* [mpllib](https://github.com/sabel83/mpllibs/)
* + MetaMonad
* + 

## Test
* [catch](https://github.com/philsquared/Catch)
* [Hippomock](https://github.com/dascandy/hippomocks)

## Lock-free
* [HPLFDS](https://github.com/yebangyu/HPLFDS)

## Machine
* PDA
* Turing

## DB
* [simdb](https://github.com/LiveAsynchronousVisualizedArchitecture/simdb)
* [cppstddb](https://github.com/cruisercoder/cppstddb)

## Macro
* Type as Macros

## YSTDEX
* [cast](https://github.com/FrankHB/YSLib/blob/dc0317b085bc99e8965b570ced94c00bfda9cd01/YBase/include/ystdex/cast.hpp)
* [construct](https://github.com/FrankHB/YSLib/blob/271b2e4e0c17866e08cdd9c5c52f90b5380cfb96/YBase/include/ystdex/placement.hpp)
* [type_traits](https://github.com/FrankHB/YSLib/blob/271b2e4e0c17866e08cdd9c5c52f90b5380cfb96/YBase/include/ystdex/type_traits.hpp)

## Natsulib
* [Exception](https://github.com/akemimadoka/NatsuLib/blob/master/NatsuLib/natException.cpp)
* [StackWalker](https://github.com/akemimadoka/NatsuLib/blob/master/NatsuLib/natStackWalker.cpp)
* Formatter
* Injector

## MCF
* [MCF](https://github.com/lhmouse/MCF/tree/master/MCF/src)
* [MCFCRT](https://github.com/lhmouse/MCF/tree/master/MCFCRT/src)

## String-operation
* formatter
* [StrTK](http://www.partow.net/programming/strtk/index.html#tutorial)
* pystring
* [fmt](https://github.com/fmtlib/fmt)
* [rethinking-string](https://github.com/vmware/rethinking-strings)
* [pystring](https://github.com/imageworks/pystring/blob/master/pystring.cpp)

## Conversion rank
* constexpr calculate of conversion rank

## itoa
* [miloyip](https://github.com/miloyip/itoa-benchmark)

## codecvt
* [codecvt](https://gcc.gnu.org/viewcvs/gcc/trunk/libstdc%2B%2B-v3/include/bits/)

## vrm
* [vrm-core](https://github.com/SuperV1234/vrm_core/tree/cfd4ac84380bdf02b6fcced6bb4a378196ffa467/include/vrm/core)

## Injector
* [GenericInjector](https://github.com/akemimadoka/GenericInjector/tree/master/GenericInjector)

## Executable format
* PE
* ELF

## Tribool

## Expression Templates
* [yap](https://github.com/tzlaine/yap)

## LLVM ADT
* [ADT](https://github.com/llvm-mirror/llvm/tree/d35f86ef8f14f9cdea6859b22615bbeddaa023fc/include/llvm/ADT)

## MemTrack
* [implementation](http://www.almostinfinite.com/memtrack.html)

## Compatibility
* fix __attribute__ vs __declspec Config